# -*- coding: utf-8 -*-
import sys, re
from bs4 import BeautifulSoup

try:
    from urllib2 import urlopen, Request, build_opener, HTTPRedirectHandler
except ImportError:
    from urllib.request import urlopen, Request, build_opener, HTTPRedirectHandler
try:
    from urlparse import urljoin, urlparse, parse_qs, urlunparse
except ImportError:
    from urllib.parse import urljoin, urlparse, parse_qs, urlunparse
try:
    from urllib import urlencode
except ImportError:
    from urllib.parse import urlencode
ua = 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/89.0.4389.114 Safari/537.36'
cookie = 'qrnum=875333;wrnum=602431'


def gethttp(url, data=None):
    request = Request(url, data, {'User-Agent': ua, 'Cookie': cookie})
    return urlopen(request).read().decode('utf-8')


def getsoup(url, data=None):
    request = Request(url, data, {'User-Agent': ua, 'Cookie': cookie})
    if (2, 7, 3) <= sys.version_info < (3, 0) or (3, 2) <= sys.version_info < (4, 0):
        return BeautifulSoup(urlopen(request), 'html.parser')
    return BeautifulSoup(urlopen(request), 'html5lib')


def video(url):
    try:
        soup = getsoup(url)
    except Exception as e:
        return {'code': 'localau 100', 'error': str(e)}
    suburl = soup.select('div.zy_box a')[0]['href']
    return cat(urljoin(url, suburl))


def play(url):
    try:
        soup = getsoup(url)
    except Exception as e:
        return {'code': 'localau 200', 'error': str(e)}
    suburl = soup.select('iframe#main')[0]['src']
    url2 = urljoin(url, suburl)
    o = urlparse(url2)
    q = parse_qs(o.query, True)
    # http://www.localmv1.com/play/147669-1-1.html
    # /player/player.php?authcode=odXJsPWh0dHA6Ly9hbWF6b24tY2xvdWRmcm9udC1zeWQtMTM4LWNkbjUuZHkyNDY4LmNvbS8yMDIwMTIvMjAyMDEyMjYvMmU4MDA4ZmZjNjQ0Yzc4OTAyYzllNjNmZjZiMWYxM2IvaW5kZXgubTN1OCZkaWQ9MTQ3NjY5LTE=ff
    if o.path == '/player/player.php':
        class r(HTTPRedirectHandler):
            newurl = ''
            def redirect_request(self, req, fp, code, msg, hdrs, newurl):
                self.newurl = newurl
                return HTTPRedirectHandler.redirect_request(self, req, fp, code, msg, hdrs, newurl)
        t = r()
        opener = build_opener(t)
        request = Request(url2, headers={'User-Agent': ua})
        opener.open(request)
        url2 = t.newurl
        o = urlparse(url2)
        q = parse_qs(o.query, True)
    # http://www.localmv1.com/play/146871-0-1.html
    # //api.localau.vip/nplayer/player/index.php?url=https://youku.cdn2-okzy.com/20200902/11243_ffbdac14/index.m3u8&did=146871-1
    if o.path == '/nplayer/player/index.php':
        return {'title': '', 'url': q['url'][0]} #, 'header': {'Referer': urlunparse((o.scheme, o.netloc, '/', '', '', '')), 'User-Agent': ua}}
    url3 = re.search(r'yunbo.html\?url=(.*)', url2)
    if url3:
        url3 = url3.group(1)
        return {'title': '', 'url': url3} #, 'header': {'Referer': url}}
    return {'code': 'localau 201'}


def sports():
    url = 'http://www.tiyu6.tv/'
    try:
        soup = getsoup(url)
    except Exception as e:
        return {'code': 'localau 300', 'error': str(e)}
    ret = []
    for e0 in soup.select('div.box'):
        date = e0.find_previous_sibling('div')['id']
        date = date[3:]
        date = date[:4] + '-' + date[4:6] + '-' + date[6:]
        for e1 in e0.select('li.gamelist'):
            title = [date]
            for e2 in e1.find_all(['span', 'div']):
                if 'style' in e2.attrs and 'display:none;' in e2['style']:
                    continue
                if 'style' in e2.attrs and 'text-align:center;' in e2['style']:
                    continue
                t = e2.find(text=True).strip()
                if not t:
                    continue
                title.append(t)
            for e2 in e1.find_all(['span', 'div']):
                if 'style' in e2.attrs and 'display:none;' in e2['style']:
                    continue
                if 'style' not in e2.attrs or 'text-align:center;' not in e2['style']:
                    continue
                t = e2.find(text=True).strip()
                if not t:
                    continue
                title.append(t)
            title = ' '.join(title)
            suburl = e1.a['href']
            ret.append({'title': title, 'url': urljoin(url, suburl)})
    return ret


def game(url):
    try:
        soup = getsoup(url)
    except Exception as e:
        return {'code': 'localau 310', 'error': str(e)}
    ret = []
    for e in soup.select('div#links a'):
        if 'href' not in e.attrs:
            continue
        if e['href'].startswith('javascript:'):
            continue
        ret.append({e.text: urljoin(url, e['href'])})
    return ret


def sport(url):
    try:
        soup = getsoup(url)
    except Exception as e:
        return {'code': 'localau 320', 'error': str(e)}
    p = soup.find('iframe', {'id': re.compile('main.*')})
    if not p:
        return {'code': 'localau 321'}
    if 'src' not in p.attrs:
        return {'code': 'localau 322'}
    url = urljoin(url, p['src'])
    o = urlparse(url)
    p = o.path.split('/')
    while p and not p[-1]:
        p = p[:-1]
    if p[-1] == 'play.html':
        return tv1(url)
    if p[-1] == 'qplay.html':
        return tv2(url)
    if o.netloc == 'api.localau.vip':
        return vip(url)
    day = re.search(r'\?day=(.*)', url)
    if day:
        try:
            content = gethttp(url)
        except:
            return {'code': 'localau 323'}
        url = re.search(r'playurl\s*=\s*"(.*?)"', content)
        if not url:
            return {'code': 'localau 324'}
        url = url.group(1)
        return {'url': {'m3u8': url}}
    return {'code': 'localau 325'}


def tv():
    return cat('http://www.localmv1.com/tv/1.html')


def cat(url):
    try:
        soup = getsoup(url)
    except Exception as e:
        return {'code': 'localau 300', 'error': str(e)}
    ret = []
    a1 = []
    for e in soup.select('div.zb_ymmenu span.lk') + soup.select('div.zb_smmenu span.lk'):
        a1.append(e.text)
    i = 0
    for e in soup.select('div.zb_ymsbox') + soup.select('div.zb_listbox'):
        a2 = []
        for e1 in e.select('a'):
            img = e1.img
            if img:
                a2.append({'title': e1['title'], 'url': urljoin(url, e1['href']), 'img': urljoin(url, img['src'])})
            else:
                a2.append({e1['title']: urljoin(url, e1['href'])})
        if a1:
            ret.append({a1[i]: a2})
            i += 1
        else:
            ret += a2
    return ret


def tv0(url):
    try:
        soup = getsoup(url)
    except Exception as e:
        return {'code': 'localau 330', 'error': str(e)}
    ret = []
    for e in soup.select('div.v-panel span.bq'):
        ret.append({e.text: e.parent['href']})
    return ret


def tv1(url):
    o = urlparse(url)
    q = parse_qs(o.query, True)
    if 'id' not in q:
        return {'code': 'localau 340'}
    return {'title': '', 'url': 'http://live.centerch.com/%s.m3u8' % q['id'][0]}


def tv2(url):
    o = urlparse(url)
    q = parse_qs(o.query, True)
    if 'id' not in q or 'hd' not in q:
        return {'code': 'localau 350'}
    return {'title': '', 'url': 'http://shbu.live.bestvcdn.com.cn:8080/live/program/live/%s/%s00000/mnf.m3u8' % (q['id'][0], q['hd'][0])}


def vip(url):
    def hv(url):
        try:
            content = gethttp(url)
        except Exception as e:
            return {'code': 'localau 361', 'error': str(e)}
        dp = re.search(r'DPlayer\((.*?)\);', content, re.DOTALL)
        if not dp:
            return {'code': 'localau 362'}
        dp = dp.group(1)
        url2 = re.search(r'url:\s*(.*?),', dp, re.DOTALL)
        if not url2:
            return {'code': 'localau 363'}
        url2 = url2.group(1)
        if url2.startswith('"') and url2.endswith('"'):
            url2 = url2[1:-1]
        if url2.startswith('//'):
            url2 = 'http:' + url2
        return {'title': '', 'url': url2}

    def live(url):
        o = urlparse(url)
        q = parse_qs(o.query, True)
        if 'url' not in q:
            return {'code': 'localau 364'}
        return {'title': '', 'url': q['url'][0]}

    def hls(url):
        try:
            content = gethttp(url)
        except Exception as e:
            return {'code': 'localau 365', 'error': str(e)}
        src = re.search(r'src: "(.*?)"', content)
        if not src:
            return {'code': 'localau 366'}
        src = src.group(1)
        return {'title': '', 'url': src}

    o = urlparse(url)
    p = o.path.split('/')
    while p and not p[-1]:
        p = p[:-1]
    if p[-1] in ('hv.php', 'hs.php'):
        # http://api.localau.vip/hs.php?id=chanel30
        return hv(url)
    elif p[-1] == 'live.html':
        return live(url)
    elif p[-1] == 'hls.php':
        return hls(url)
    else:
        return {'code': 'localau 360'}


def category(cat, page=1):
    url = 'http://www.localmv1.com/list/%s____%d.html' % (cat, page)
    try:
        soup = getsoup(url)
    except Exception as e:
        return {'code': 'localau 400', 'error': str(e)}
    ret = []
    for e in soup.select('ul.ztc_list li.item'):
        e1 = e.find('a')
        e2 = e1.find('div')
        plot = []
        for e3 in e2.select('div.bot span'):
            plot.append(e3.text.strip())
        for e3 in e1.select('div.fz'):
            plot.append(e3.text.strip())
        plot = '\n'.join(plot)
        ret.append({'title': e1['title'], 'url': urljoin(url, e1['href']), 'img': urljoin(url, e2.img['data-echo']), 'plot': plot})
    if soup.select('div.w-pages a.next'):
        ret.append({'title': 'Next Page (%d)' % (page + 1), 'category': cat, 'page': page + 1})
    return ret


def search(s):
    url = 'http://www.localmv1.com/search/'
    try:
        soup = getsoup(url, urlencode({'wd': s}).encode('utf-8'))
    except Exception as e:
        return {'code': 'localau 500', 'error': str(e)}
    ret = []
    for e in soup.select('div.ss_l ul.ss_list li.item'):
        img = e.select('img')[0]['data-echo']
        e1 = e.select('div.info a.title')[0]
        suburl = e1['href']
        if suburl.startswith('/play/') and suburl.endswith('.html'):
            suburl = suburl[6:-5]
            suburl = '/video/%s.html' % suburl.split('-')[0]
        elif suburl.startswith('/video/') and suburl.endswith('.html'):
            pass
        else:
            continue
        plot = []
        for e2 in e.select('div.info div.desc span.clamp a'):
            e2.extract()
        for e2 in e.select('div.info div.desc span'):
            plot.append(e2.text.strip())
        plot = '\n'.join(plot)
        ret.append({'title': e1.text, 'url': urljoin(url, suburl), 'img': urljoin(url, img), 'plot': plot})
    return ret
